#include "StdAfx.h"
#include ".\mymodart.h"

#include "MyLine.h"

MyModArt::MyModArt(void)
{
	srand((unsigned)time(NULL));
}

MyModArt::~MyModArt(void)
{
}

//     Drawing Area
void MyModArt::SetRect(CRect rDrawArea)
{
	m_rDrawArea = rDrawArea;
}

//     
void MyModArt::NewLine()
{
	int iNumLines;
	int iCurLine;
	int iCurColor;
	unsigned int iCurWidth;
	CPoint ptBegin;
	CPoint ptEnd;

	static COLORREF crColors[8] = {
		//  
		RGB(   0,   0,   0), // Black	-  
		RGB(   0,   0, 255), // Blue	- 
		RGB(   0, 255,   0), // Green	- 
		RGB(   0, 255, 255), // Cyan	- 
		RGB( 255,   0,   0), // Red		- 
		RGB( 255,   0, 255), // Magenta	- 
		RGB( 255, 255,   0), // Yellow	- 
		RGB( 255, 255, 255)  // White	- 
	};

	//  (Normalize)  
	//     
	m_rDrawArea.NormalizeRect();

	//      
	int iWidth = m_rDrawArea.Width();
	int iHeight = m_rDrawArea.Height();

	//      
	while(!(iNumLines = rand() % 100));

    iCurColor = rand() % 8;			//  
	iCurWidth = (rand() % 8) + 1;	//  
	//       
	ptBegin.x = (rand() % iWidth) + m_rDrawArea.left;
	ptBegin.y = (rand() % iHeight) + m_rDrawArea.top;

	//   
	for(iCurLine = 0; iCurLine < iNumLines; iCurLine++){
		//    
		ptEnd.x = ((rand() % 20) - 10) + ptBegin.x;
		ptEnd.y = ((rand() % 20) - 10) + ptBegin.y;

		MyLine *pLine = NULL;
		try // 
		{
			//      MyLine
			pLine = new MyLine(ptBegin, ptEnd);
			pLine->Set(crColors[iCurColor], iCurWidth);
			//      
			m_oaLines.Add(pLine);
		}
		catch(CMemoryException *perr) //   
		{
			AfxMessageBox("  ", MB_ICONSTOP | MB_OK);
			if(pLine){
				delete pLine;
				pLine = NULL;
			}
			perr->Delete(); //  -
		}

		//     
		ptBegin = ptEnd;
	} // End of for
}

//   
void MyModArt::NewDrawing(void)
{
	int iNumLines;

	//    
	while(!(iNumLines = rand() % 10));

	//  
	for(int iCurLine = 0; iCurLine < iNumLines; iCurLine++)
		NewLine();
}


//   
void MyModArt::Draw(CDC* pDC)
{
	//     
	int iCount = m_oaLines.GetSize();

	if(!iCount) //    
		return;

	//   
	for(int iPos = 0; iPos < iCount; iPos++)
		((MyLine*)m_oaLines.GetAt(iPos))->Draw(pDC);	
}

//    
void MyModArt::Serialize(CArchive& ar)
{
	//     
	m_oaLines.Serialize(ar);
}

//  
void MyModArt::ClearDrawing(void)
{
	//     
	int iCount = m_oaLines.GetSize();

	//   
	for(int iPos = 0; iPos < iCount; iPos++)
		delete m_oaLines.GetAt(iPos);	

	m_oaLines.RemoveAll();
}
